import greenfoot.Color;
import greenfoot.Greenfoot;
import packages.ui.*;

public class Result extends UIWorld {

    public Result(Game.Statistics stats) {
        super(600, 400, 1);
        getBackground().setColor(MainMenu.BKG_COLOR);
        getBackground().fill();


        String score = "" + stats.realScore() * 0.2;
        try{
            score = score.substring(0, score.indexOf(".") + 2);
        }catch(Exception e) {}
        add(new Text("Score: " + score, 30, Color.RED), 0.5, 0.5);
        add(new Text("Clicks: " + (stats.totalClicks - stats.wrongClicks - stats.missedClicks), 20, Color.GRAY), 0.5, 0.6);
        add(new Text("Difficulty factor: " + stats.difficulty * 20 + "%", 20, Color.GRAY), 0.5, 0.65);
        add(new Text("Total clicks: " + stats.totalClicks, 16, Color.GRAY), 0.5, 0.73);
        add(new Text("Wrong clicks: " + stats.wrongClicks, 16, Color.GRAY), 0.5, 0.77);
        add(new Text("Missed clicks: " + stats.missedClicks, 16, Color.GRAY), 0.5, 0.81);
        add(new Fade(Color.DARK_GRAY, 1, true), 0.5, 0.5);

        Button b = new Button("Scoreboard");
        b.addClickAction(info -> Greenfoot.setWorld(new Scoreboard()));
        add(b, MainMenu.BACK_X, MainMenu.BACK_Y);
        b = new Button("Restart", b.getImage().getWidth(), b.getImage().getHeight());
        b.addClickAction(info -> Greenfoot.setWorld(Setup.getInstance()));
        add(b, 1 - MainMenu.BACK_X, MainMenu.BACK_Y);
    }
}