import greenfoot.Color;
import greenfoot.Greenfoot;
import greenfoot.UserInfo;
import packages.ui.*;

public class Scoreboard extends UIWorld{


    public Scoreboard(){
        super(600, 400, 1);
        getBackground().setColor(MainMenu.BKG_COLOR);
        getBackground().fill();

        add(new Text("High scores", 30, Color.RED), 0.5, 0.1);

        Button b = new Button("Main menu");
        b.addClickAction(info -> Greenfoot.setWorld(new MainMenu()));
        add(b, MainMenu.BACK_X, MainMenu.BACK_Y);

        add(new packages.ui.Scoreboard(500, 290) {
            public ScorePanel getScorePanelFor(int width, int index, UserInfo user) {
                return new ScorePanel(width, user, index) {
                    protected void addAdditionalInfo(Color color) {
                        Text text = new Text("Difficulty: " + user.getInt(0), 16, color);
                        add(text, 0.6, 0.5, text.getImage().getWidth() / 2, 0);
                    };
                };
            };
        }, 0.5, 0.55);
    }

    @Override
    public void act() {
        if("escape".equals(Greenfoot.getKey())) Greenfoot.setWorld(new MainMenu());
    }



    public static void clearScores() {
        try{
            UserInfo user = UserInfo.getMyInfo();
            user.setScore(0);
            user.setInt(0, 0);
            user.store();
            
        }catch(Exception e) {
            System.out.println("Failed");
        }
    }
}