import greenfoot.Color;
import greenfoot.Greenfoot;
import packages.ui.*;

public class Setup extends UIWorld{

    private static Setup instance;

    private final Slider difficultySlider;
    private final NumberField difficultyField;

    private Setup(){
        super(600, 400, 1);
        getBackground().setColor(MainMenu.BKG_COLOR);
        getBackground().fill();

        difficultySlider = new Slider(1, 10, 150);
        difficultySlider.allowFractions(false);
        difficultyField = new NumberField(new Text("Enter difficulty"), false);
        difficultyField.addClickAction(info -> {
            int entered = difficultyField.getInt();
            if(entered < 1) {
                entered = 1;
                difficultyField.setTitle("Difficulty: 1");
            }
            else if(entered > 10) {
                entered = 10;
                difficultyField.setTitle("Difficulty: 10");
            }
            difficultySlider.setValue(entered);
        });

        add(new Text("New game", 25, Color.RED), 0.5, 0.2);
        add(new Text("Choose difficulty", 18, Color.LIGHT_GRAY), 0.5, 0.55);
        add(difficultySlider, 0.5, 0.6);
        add(difficultyField, 0.5, 0.66);
        add(new Text("Higher difficulty will increase your final score", 15, Color.LIGHT_GRAY), 0.5, 0.95);

        difficultySlider.setValue(3);

        Button b = new Button("Start game", MainMenu.B_WIDTH, MainMenu.B_HEIGHT);
        b.addClickAction(info -> Greenfoot.setWorld(new Game(difficultySlider.getIntValue())));
        add(b, 0.5, 0.82);

        b = new Button("Main menu");
        b.addClickAction(info -> Greenfoot.setWorld(new MainMenu()));
        add(b, MainMenu.BACK_X, MainMenu.BACK_Y);
    }

    @Override
    public void act() {
        difficultyField.setTitle("Difficulty: " + difficultySlider.getIntValue());
        if("escape".equals(Greenfoot.getKey())) Greenfoot.setWorld(new MainMenu());
    }

    public static Setup getInstance() {
        if(instance == null) instance = new Setup();
        return instance;
    }
}