package packages.event;

/**
 * An action is a simple interface that features the method
 * {@code run()}. The action is used to be executed when a certain
 * event occures, for example a button being clicked.
 */
public interface Action {

    /**
     * This method gets executed when the event occures.
     * 
     * @param eventInfo An object containing information about the specific event
     * that occured. All methods that execute this method should note what kind
     * of object will be passed to avoid casting errors. If no information is given
     * in the documentation, the object should be considered to be {@code null}.
     */
    public void run(Object eventInfo);
}
