package packages.geometry;

public class Transform implements Cloneable {

    /**
     * Do not set to {@code null}!
     */
    public Vector location;

    /**
     * Do not set to {@code null}!
     */
    public Rotation rotation;

    /**
     * Do not set to {@code null}!
     */
    public Vector scale;


    public Transform() {
        this(new Vector(), new Rotation(), new Vector(1, 1, 1));
    }
    public Transform(Transform copy) {
        this(
            copy.location.clone(),
            copy.rotation.clone(),
            copy.scale.clone()
        );
    }
    public Transform(Vector location) {
        this(location, new Rotation(), new Vector(1, 1 ,1));
    }
    public Transform(Vector location, Rotation rotation, Vector scale) {
        this.location = location;
        this.rotation = rotation;
        this.scale = scale;
    }



    @Override
    public Transform clone() {
        return new Transform(this);
    }
}
