package packages.ui;

import greenfoot.*;

public class Fade extends Actor {
    
    public final Color color;
    public final long duration;
    public final boolean fadeIn;

    private long startTime, endTime;

    public Fade(Color color, double seconds, boolean fadeIn) {
        this.color = color;
        duration = (long)(seconds * 1000000000);
        this.fadeIn = fadeIn;
    }


    @Override
    protected void addedToWorld(World w) {
        startTime = System.nanoTime();
        endTime = startTime + duration;
        GreenfootImage image = new GreenfootImage(w.getWidth(), w.getHeight());
        image.setColor(color);
        image.fill();
        setImage(image);
    }


    @Override
    public void act() {
        long time = System.nanoTime();
        if(time > endTime) {
            getWorld().removeObject(this);
            return;
        }
        if(fadeIn) getImage().setTransparency((int)(255 * (1 - (time - startTime) / (double)duration)));
        else getImage().setTransparency((int)(255 * (time - startTime) / (double)duration));
    }
}
